%--------------------------------------------------------------------------
function v = FCM_gabi(F,c,iter)
%--------------------------------------------------------------------------
[m,n] = size(F);

mn = m*n;


f = reshape(F,mn,1);

x = (max(F(:))-min(F(:)))/c;
v=zeros(c,1);
for i = 1:c
    v(i) = (i - 1) * x + x / 2;
end

w = zeros(mn,c);
u = zeros(mn,c);  %nur als Speicherreservierung

%[sortedF,sind] = sort(f);
for k = 1:iter

    s = zeros(mn,1);
    p = ones(mn,c);

    for i = 1:c
        %median problem: will become 0 at the median component
        w(:,i) = abs((f - v(i) )).^2;
    end

    for i = 1:c
        for j = 1:c
            if j ~= i
                p(:,i) = p(:,i).*w(:,j);
            end
        end
        s = s + p(:,i);
    end
    for i = 1:c
        u(:,i) = p(:,i)./s;

        % calculate weighted median.
        %tW = u(:,i).^2;
        %tW = tW(sind);
        %norm(tW)
        %v(i) = weighted_median(sortedF,tW);
        v(i) = sum(u(:,i).^2.*f)/sum(u(:,i).^2);
    end
    
    %fprintf('it:%g\n',k);
end

% U = reshape(u,m,n,c);

%[ U_cb, U_lab ] = assignlabel( U,v );

%figure(6);
%imagesc(U_cb);colormap(gray);axis square;

